# Hackers

![Hackers](https://github.com/weiran/Hackers/workflows/Hackers/badge.svg?branch=master)

Hackers is an iPhone and iPad app for reading Hacker News on the go. It's optimised for quickly catching up on the latest news and comments without getting in your way.

## Features

* Thumbnails generated for posts
* Collapsable comments threads
* iOS 13 dark mode
* Full iPad multitasking support
* Safari View Controller
* Upvote posts and comments
* Open In Hackers share extension

<img src="https://user-images.githubusercontent.com/1109819/162569111-f05c2511-99fa-40ba-80f1-b11774fc4611.png" width="350">

## Open Source

Hackers is open source and licenced under the MIT licence.

## Download

[![Download in App Store][3]][2] 

Or install the [latest beta version from TestFlight][4].

[2]: https://itunes.apple.com/gb/app/hackers-hacker-news-reading/id603503901?at=11l4G8&ct=github
[3]: http://i.imgur.com/oRdf2WM.png
[4]: https://testflight.apple.com/join/UDLeEQde

## Links

* I wrote [a blog post introducing Hackers](http://weiran.co/blog/2013/3/hackers-a-hacker-news-app-for-iphone). 
* You can follow [Hackers' progress on my blogs tagged Hackers](http://weiran.co/?tag=hackers).
* You can also get in touch via Twitter: [@weiran](https://twitter.com/weiran).


## Generate screenshots

1. Install [fastlane](https://fastlane.tools).
2. Run `fastlane screenshots` in `/fastlane`

## Credits

I use several open source projects in Hackers, in no particular order:

* [HNScraper](https://github.com/tsucres/HNScraper)
* [PromiseKit](https://github.com/mxcl/PromiseKit)
* [Nuke](https://github.com/kean/Nuke)
* [Loaf](https://github.com/schmidyy/Loaf)
* [SwipeCellKit](https://github.com/SwipeCellKit/SwipeCellKit)
* [Swinject](https://github.com/Swinject/Swinject)
* [SwiftLint](https://github.com/realm/SwiftLint)
* [DeviceKit](https://github.com/devicekit/DeviceKit)
* [WhatsNewKit](https://github.com/SvenTiigi/WhatsNewKit)

---
<p align="center">
  <b>By Weiran Zhang</b><br>
  <a href="https://weiran.co">Website</a> |
  <a href="https://twitter.com/weiran">Twitter</a> |
  <a href="https://github.com/weiran">GitHub</a>
</p>
